"""Echo command line arguments


"""

__author__ = "Jason Wong"
__version__ = "$Revision: 1.0 $"
__date__ = "$Date: 2011/06/27 10:06:20 $"
__copyright__ = "Copyright (c) 2011 Jason WH Wong"
__license__ = "UNSW Faculty of Medincine"

import sys
import os
import getopt
import tokenize
import StringIO
import gzip

class datapoint:
      mass = 0
      rt = 0
      intn = 0
      transition = None
      mass_list = []
      rt_list = []
      samples = []
      intn_list = []
      active = 1
      rt_shift = []

class mergeCGH_samples:

    def __init__(self):
        self.outFile = None
        self.outFileDiff = None
        self.inputFiles = None
        self.data = []
        self.files = []
        self.mass_win = 0.25
        self.rt_win = 0.5

    def readInputFile(self):
        #print "Reading input Files..."
        try:
          f = open(self.inputFiles,'r')
          tmp= []
          for line in f:
              line = line[0:-1]
              if len(line) > 0 and line[0] <> "#":
                self.files.append(line)
          f.close()
        except IOError:
               files = os.listdir(self.inputFiles)
               for i in files:
                   self.files.append(self.inputFiles+"//"+i[:-4])
        #print self.files

    def avg_list(self,l):
        if len(l) == 0:
           return 0.0
        val = 0.0
        for i in l:
            val+=i
        return float(val)/float(len(l))

    def readLipidMS(self):
        print "reading MMSAT files"
        for i in self.files:
            f = open(i,'r')
            print i
            for line in f:
                line = line[:-1]
                tmp = line.split("\t")
                found = 0
                if len(line) > 0 and tmp[0] <> 'mass':
                   #print i+"\t"+line
                   for j in self.data:           # first check if a mass/rt data point already exists
                    if tmp[6] == j.transition and float(tmp[0])<j.mass+self.mass_win and float(tmp[0])>j.mass-self.mass_win and float(tmp[1])<j.rt+self.rt_win and float(tmp[1])>j.rt-self.rt_win:
                       found = 1
                       found2 = 0
                       for k in range(0,len(j.samples)):
                          if os.path.basename(i) == j.samples[k]:
                             found2 = 1
                             if j.intn_list[k] < float(tmp[2]):   # if one sample has two points both matching to one datapoint, take the higher one
                                j.intn_list[k]=float(tmp[2])
                                j.rt_list[k]=float(tmp[1])
                                j.mass_list[k]=float(tmp[0])
                       if found2==0:
                         j.samples.append(os.path.basename(i))
                         j.mass_list.append(float(tmp[0]))
                         j.rt_list.append(float(tmp[1]))
                         j.intn_list.append(float(tmp[2]))
                         j.rt_shift.append(0)
                         j.mass = self.avg_list(j.mass_list)
                         j.rt = self.avg_list(j.rt_list)
                       break
                   if found== 0:
                       newData = datapoint()
                       newData.mass = float(tmp[0])
                       newData.rt = float(tmp[1])
                       newData.transition = tmp[6]
                       newData.samples.append(os.path.basename(i))
                       newData.mass_list.append(float(tmp[0]))
                       newData.rt_list.append(float(tmp[1]))
                       newData.intn_list.append(float(tmp[2]))
                       newData.rt_shift.append(0)
                       newData.active = 1
                       tmpData = datapoint()
                       tmpData.mass = newData.mass
                       tmpData.rt = newData.rt
                       tmpData.transition = newData.transition
                       tmpData.samples = newData.samples[:]
                       tmpData.mass_list = newData.mass_list[:]
                       tmpData.rt_list = newData.rt_list[:]
                       tmpData.intn_list = newData.intn_list[:]
                       tmpData.rt_shift = newData.rt_shift[:]
                       tmpData.active = newData.active
                       self.data.append(tmpData)
                       del newData.samples[:]
                       del newData.mass_list[:]
                       del newData.rt_list[:]
                       del newData.intn_list[:]
                       del newData.rt_shift[:]
            f.close()


        for i in range(0,len(self.data)):                         # merge averaged ranges
            for j in range(i+1,len(self.data)):
                if self.data[j].active == 1 and self.data[i].active == 1 and self.data[i].transition == self.data[j].transition and ((self.data[i].mass > self.data[j].mass-self.mass_win and self.data[i].mass < self.data[j].mass+self.mass_win and self.data[i].rt > self.data[j].rt-self.rt_win and self.data[i].rt < self.data[j].rt+self.rt_win)):# or (self.data[i].mass > self.data[j].mass-3.2 and self.data[i].mass < self.data[j].mass+3.2 and self.data[i].rt > self.data[j].rt-0.25 and self.data[i].rt < self.data[j].rt+0.25)):
                   self.data[j].active = 0
                   for l in range(0,len(self.data[j].samples)):
                       found = 0
                       for k in range(0,len(self.data[i].samples)):
                           if self.data[i].samples[k] == self.data[j].samples[l]:
                              if (self.data[j].intn_list[l] > self.data[i].intn_list[k]):
                                 self.data[i].mass_list[k] = (self.data[i].mass_list[k]+self.data[j].mass_list[l])/2.0
                                 self.data[i].rt_list[k] = (self.data[i].rt_list[k]+self.data[j].rt_list[l])/2.0
                              self.data[i].intn_list[k] += self.data[j].intn_list[l]
                              found = 1
                       if found == 0:
                          self.data[i].samples.append(self.data[j].samples[l])
                          self.data[i].mass_list.append(self.data[j].mass_list[l])
                          self.data[i].rt_list.append(self.data[j].rt_list[l])
                          self.data[i].intn_list.append(self.data[j].intn_list[l])
                          self.data[i].rt_shift.append(0)
                   self.data[i].mass = self.avg_list(self.data[i].mass_list)
                   self.data[i].rt = self.avg_list(self.data[i].rt_list)
            pos = 0
            for j in self.data[i].rt_list:
                self.data[i].rt_shift[pos] = j-self.data[i].rt
                pos+=1
                   #print "SDFSDFSDF"
                   #print str(len(self.data[i].rt_shift))+"\t"+ str(len(self.data[i].rt_list))+"\t"+ str(len(self.data[i].intn_list))

        out = open(self.outFile,'w')
        out.write("Mass\tRT(mins)\tTransition\t")
        for i in self.files:
            name = os.path.basename(i).split(".")[0]
            out.write(name+"\t")
        out.write("Count\n")
        for i in self.data:
          if i.active == 1:
            out.write(str(i.mass)+"\t"+str(i.rt)+"\t"+i.transition+"\t")
            for j in self.files:
                found = 0
                for k in range(0,len(i.samples)):
                    if os.path.basename(j) == i.samples[k]:
                       found = 1
                       out.write(str(i.intn_list[k])+"\t")
                if found == 0:
                   out.write('-\t')
            out.write(str(len(i.samples)))
            out.write("\n")
        out.close()
        
        out = open(self.outFileDiff,'w')
        out.write("Mass\tRT(mins)\tTransition\t")
        for i in self.files:
            name = os.path.basename(i).split(".")[0]
            out.write(name+"\t")
        out.write("Count\n")
        for i in self.data:
          if i.active == 1:
            out.write(str(i.mass)+"\t"+str(i.rt)+"\t"+i.transition+"\t")
            for j in self.files:
                found = 0
                for k in range(0,len(i.samples)):
                    if os.path.basename(j) == i.samples[k]:
                       found = 1
                       out.write(str(i.rt_shift[k])+"\t")
                if found == 0:
                   out.write('-\t')
            out.write(str(len(i.samples)))
            out.write("\n")
        out.close()

    def ParseCommandLine(self, Arguments):
        try:
            (Options, Args) = getopt.getopt(Arguments, "hi:o:m:r:d:")
        except:
            print "Unknown option entered"
            print UsageInfo
            sys.exit(1)
        OptionsSeen = {}
        for (Option, Value) in Options:
            OptionsSeen[Option] = 1
            if Option == "-i":
                self.inputFiles = Value
            elif Option == "-o":
                self.outFile = Value
            elif Option == "-d":
                self.outFileDiff = Value
            elif Option == "-m":
                self.mass_win = float(Value)
            elif Option == "-r":
                self.rt_win = float(Value)
            else:
                print "** Unknown option:", Option, Value
        if not self.inputFiles:
            print "\n* Error: -i missing"
            print UsageInfo
            sys.exit(1)

UsageInfo = """
merge_LipidMS.py - add type to translated

Parameters:
 -i [FILENAME] input file
 -o [FILENAME] Output file
 -m [CUTOFF] mass window
 -r [CUTOFF] rt window

Example:
  merge_LipidMS.py -i in.fasta -d seg.txt -o out.fasta -x existing.fasta
"""

def Main(ex = None):
    global MAX_RESULTS_FILES_TO_PARSE
    if not ex:
        ex = mergeCGH_samples()
        ex.ParseCommandLine(sys.argv[1:])
        ex.readInputFile()
        ex.readLipidMS()

if __name__ == "__main__":
    try:
        import psyco
        psyco.full()
    except:
        print ""
    #TestMain()
    Main()